
int frameaudio, grab_setup, frame, local_frame, avi_bpos, avi_need, state, video;
char four [5], *wb;
uint32_t bs32;


void state1 (void) {state = 1; avi_bpos = 0; avi_need = 8;}


int fc (char *fo) {
  for (i = 0; i < 4; i++) {if (four[i] != fo[i]) return 0;}
  return 1;
}


void grab_avi (int rate, int period, int ttalk, int ei) {
  frameaudio += (rate / 1000) * period;
  if (frameaudio > (rate * 3) || !grab_setup) frameaudio = rate * 3;
  grab_setup = 1;
  
  if (sync_play && (!video || u[0].x) && !ttalk) return; /* stdin on hold */

  while (1) {
    if (!video) avi_need = frameaudio * 2;
    ret = read(0, bv.b + avi_bpos, avi_need); /* read stdin */
    if (!ret) return; /* eof */
    if ((ret < 0) && (EAGAIN == errno || EWOULDBLOCK == errno || EINTR == errno)) return;
    if (ret < 0) err(1, "read(stdin)");
    avi_bpos += ret;
    avi_need -= ret;
    if (!video) {
      bz.m = ret;
      frameaudio -= bz.m / 2;
      realloc_b(bz.m, &bz);
      memcpy(bz.b, bv.b, bz.m);
      if (ei) dither(&bz, 1);
      if (ttalk) se(5, 0, talk_ch, ei, interrupt);
      interrupt = 0;
      state1();
      if (frameaudio < 0) return; /* send audio slowly */
      continue;
    }

    if (!avi_need) {
      if (3 == state) { /* chunk body loaded */
      
        if (fc("avih")) {
          memcpy(&bs32, bv.b + 32, 4);
          u[0].x = le32toh(bs32);
          memcpy(&bs32, bv.b + 36, 4);
          u[0].y = le32toh(bs32);
          se(3, popup, 3, u[0].x, u[0].y); /* send framesize (raw rgb 3 bpp) */
        }
        if (fc("00dc")) {
          /* frame ready */
          frame = 1;
          local_frame = 1;
          realloc_b(bv.m, &bframe);
          bframe.m = bv.m;
          memcpy(bframe.b, bv.b, bv.m);
          
          state1();
          return;
        }
        if (!wb && fc("01wb")) wb = "01wb";
        if (!wb && fc("00wb")) wb = "00wb";
        if (wb && fc(wb) && ttalk && TG(send_a)) {
          realloc_b(bv.m, &bz);
          memcpy(bz.b, bv.b, bv.m);
          bz.m = bv.m;
          if (ei) dither(&bz, 1);
          se(5, 0, talk_ch, ei, interrupt); /* send audio */
          interrupt = 0;
        }

        state1();
        continue;
      }
      if (2 == state) { /* list fourcc loaded */
        memcpy(four, bv.b, 4); four[4] = 0;
        /* fprintf(stderr, "  (fourcc=%s)\n", four); */
        state1();
        continue;
      }
      if (1 == state) { /* chunk header loaded */
        memcpy(four, bv.b, 4);
        four[4] = 0; /* fprintf(stderr, "chunk %s\n", four); */
        memcpy(&bs32, bv.b + 4, 4);
        bv.m = le32toh(bs32);
        if (bv.m & 1) bv.m++; /* parity */
        /* fprintf(stderr, "  size 0x%x\n", bv.m); */
        if (fc("LIST") || fc("RIFF")) {
          state = 2;
          avi_need = 4;
          avi_bpos = 0;
        } else {
          state = 3;
          avi_need = bv.m;
          avi_bpos = 0;
          realloc_b(bv.m, &bv);
          if (!bv.m) state1(); /* empty chunk */
        }
        continue;
      }
    }
  }
}
